package mx.italika.prod.italika.model.bean;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import lombok.Data;
import mx.italika.prod.italika.model.entity.UsuarioEntity;
@Data
public class UsuarioBean  implements UserDetails, Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String username;
    private String password;
    private String rol;
    private String nombre;
    private String aPaterno;
    private String aMaterno;
    List<String> roles;
    
    public UsuarioBean(){
        super();
    }
    public UsuarioBean(UsuarioEntity usuarioEntity) {
        this.username = usuarioEntity.getUsername();
        this.password = usuarioEntity.getPassword();
        this.roles = (usuarioEntity.getTblUsuarioRols() != null)
                ? usuarioEntity.getTblUsuarioRols()
                        .stream()
                        .map(role -> role.getIdRol().getNombre())
                        .toList() 
                : List.of(); 
    }


    

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        if (roles != null) {
            return roles.stream()
                    .map(SimpleGrantedAuthority::new) 
                    .toList();
        }
        return List.of();
    }


    @Override
    public String getPassword() {
        return password;
    }

    @Override
    public String getUsername() {
        return username;
    }
}
